pipeline {
    agent none

    stages {
        stage("build") {
            agent {
                docker {
                    image "aleksuudocker/nj8:latest"
                }
            }
            steps {
                dir ("website") {
                    sh "npm i"
                    sh "npm run build"
                }
            }
            post {
                success {
                    archiveArtifacts artifacts: "website/build/test-site/", fingerprint: true
                }
            }
        }
        stage("test"){
            parallel {
                stage("code analisys") {
                    agent {
                        docker {
                            image "aleksuudocker/nj8:latest"
                            args "--network lab10usuario31_devopsjenkins"

                        }
                    }
                    environment {
                        scannerHome = tool "SonarQubeScanner"
                    }

                    steps {
                        withSonarQubeEnv("sonarqube") {
                            sh "${scannerHome}/bin/sonar-scanner"
                        }
                        //timeout(time: 10, unit: "MINUTES") {
                          //  waitforQualityGate abortPipeline: true
                       // }
                    }

                }
                stage('funcional') {
                    agent {
                        docker{
                            image 'node'
                        }
                    }
                    steps {
                        dir('website') {
                            sh 'npm i'
                            sh 'npm i -g wait-on broken-link-checker'
                            sh 'setsid npm start >/dev/null 2>&1 < /dev/null &'
                            //sh 'wait-on http://localhost:3000 && blc --recursive --exclude-external http://localhost:3000'
                                
                        }
                    }
                }
                stage('security') {
                    agent {
                        docker {
                            image 'node'


                        }
                    }
                    steps {
                        dir('website') {
                            sh 'npm i -g npm-audit-pipeline'
                            sh 'npm-audit --low=5 --moderate=5 --high=5 --critical=5'
                            
                        }
                    }
                }
            }
        }
        stage('build image') {
            agent {
                docker {
                    image 'docker'
                }
            }
            steps {
                script {
                    dockerImage = docker.build 'aleksuudocker/docusaurus:latest'
                    docker.withRegistry('', 'dockerhub') {
                        dockerImage.push()
                    }
                }
            }
        }   
    }
}